%main.m  -Andy Ruina  March 4, 2019
% No changes on March 6, just repeated for completeness
% A bunch of particles. Well,  2 of them, Using ODE45
% And animation
clear  . 

% Setup tarray (note tarray does not set accuracy in ODE45)
tend        = 4;                      %  Ending time "t end"
npointspers = 60;                       %  number of h intervals per time unit
ntimes      = tend * npointspers + 1;   %  total number of time points
tarray      = linspace(0, tend, ntimes);%  All of the times soln is output

%CConsants 
p.m1 = 1;   p.m2 = 2;   % masses
p.G   = 1;

%ICs.  Initial conditions
r10 = [0;0];   r20 = [1;0]; r0 = [r10; r20];
v10 = [0;0];   v20 = [0;1]; v0 = [v10; v20];
z0 =  [r0;v0];

% USE ODE45. Next  line gets the solution to the ODES
small = 1e-4;  % 1e-3 to -14.  
%ODE45 uses the easier-to-achieve of these two
options = odeset('RelTol', small, 'AbsTol', small);
f = @(t,z)  myrhs(t,z,p); % "Anonymous" function definition
[tarray zarray]   = ode45(f, tarray, z0,options);

t= tarray;
x1 = zarray(:,1); y1 = zarray(:,2);   % Extract the two columns of zarray
x2 = zarray(:,3); y2 = zarray(:,4);   % Extract the two columns of zarray

xcom = (x1*p.m1 + x2*p.m2)/(p.m1+ p.m2); %Center of mass array
ycom = (y1*p.m1 + y2*p.m2)/(p.m1+ p.m2);

%Trajectory rel to center of mass
x1rel = x1 - xcom;   x2rel = x2 - xcom; % Motion rel to Center of mass
y1rel = y1 - ycom;   y2rel = y2 - ycom;

%PLOTS
figure(1); shg;
for i = 1:ntimes  %Animation loop

xcom = (x1(i)*p.m1 + x2(i)*p.m2)/(p.m1+ p.m2); %Present Center of mass
ycom = (y1(i)*p.m1 + y2(i)*p.m2)/(p.m1+ p.m2);

%Trajectory rel to center of mass, added to to present CoM
plot (x1rel+xcom,y1rel+ycom, x2rel+xcom,y2rel+ycom,'LineWidth',1); hold on


plot (x1,y1, x2,y2,'LineWidth',1);  %Actual trajectory
plot (x1(i),y1(i), '.', 'MarkerSize',40);  %present location of m1
plot (x2(i),y2(i), '.', 'MarkerSize',40);  %present location of m2
plot (xcom, ycom, '.k', 'MarkerSize',20);  %present location of CoM
hold off
axis equal;                    % Plot y vx s

axis equal;       %x and y scale the same
ylabel('$y$','interpreter','latex'); % Nice looking math
xlabel('$x$','Interpreter','latex'); 
title(['Rel to COM. -A. Ruina   ' datestr(now)])
pause(.01);  
end % end of animation loop

